<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="21" :spanTitle="2" title="Regresar" v-on:clickEvent="returnPage" style="margin-bottom:2.5rem"></ReturnButton>
      <el-row :gutter="20">
        <!-- BUSCADOR --> 
        <el-col :span="6" :offset="18">
          <app-search-filter v-model="textSearch"></app-search-filter>
        </el-col>  
      </el-row>
       <!-- <el-row :gutter="20">
          <el-col :span="15" class="text-end">
            <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
          </el-col>
          <el-col :span="9">
           <el-autocomplete
              v-model="originalTitle"
              style="width: 100%;"
              size="small"
              :fetch-suggestions="querySearch"
              :trigger-on-focus="false"
              @select="handleSelect">
              <template slot-scope="props">
                <div>{{ props.item[filterSelect] }}</div>
              </template>
            </el-autocomplete>
          </el-col>  
      </el-row> -->
    </header>

   <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
      <app-title :Title="'ALMACEN DE '+ typeContent + ' TELEVISA'" > </app-title>
    </div>

    <!-- Leyenda -->
    <div style="margin:3rem 6rem">
      <el-row>
        <el-col :span="22" :offset="1">
          <h5 style="margin: 2rem 0"> ESTADO DE LOS MATERIALES </h5>
        </el-col>
      </el-row>
      
      <DescriptionStateOrders v-if="typeContent == 'LARGOMETRAJES' || typeContent == 'MINISERIES'"
                              :TextSquareBlue="''" :TextSquareOrange="''" :TextSquareGray="'Pendiente'" :TextSquarePurple="''"
                              :TextSquareRed="'Pendiente de Reposición'" :TextSquareGreen="'Copiado'" :colBoxes="6"> 
      </DescriptionStateOrders>
      <DescriptionStateOrders v-else-if="typeContent == 'NOVELAS' || typeContent == 'SERIES' || typeContent == 'DIBUJOS'"
                              :TextSquareBlue="''" :TextSquareOrange="''" :TextSquareGray="'No se ha copiado ningún capítulo'" :TextSquarePurple="''"
                              :TextSquareRed="'Capítulos incompletos'" :TextSquareGreen="'Capítulos completos'"> 
      </DescriptionStateOrders>
      <el-row type="flex" justify="space-between" v-else>
        <el-col :span="24">
          <el-row>
            <el-col :span="11" :offset="1">
              <h4 style="margin-bottom: 10px">{{typeContent}} SIN CAPÍTULOS</h4>
              <div style="margin: 8px 0" v-for="(item, index) in withoutCaps" :key="index">
                <div class="flex element-bloq-center" > 
                  <div :class="item.style" class="border-radius-light" style="margin-right:1rem; height:25px; width:25px"></div> 
                  <span>{{item.name}}</span>
                </div>
              </div>
            </el-col>
            <el-col :span="10" :offset="2">
              <h4 style="margin-bottom: 10px">{{typeContent.toUpperCase()}} CON CAPÍTULOS</h4>
              <div style="margin: 8px 0" v-for="(item, index) in withCaps" :key="index">
                <div class="flex element-bloq-center" > 
                  <div :class="item.style" class="border-radius-light" style="margin-right:1rem; height:25px; width:25px"></div> 
                  <span>{{item.name}}</span>
                </div>
              </div>
            </el-col>
          </el-row>
        </el-col>
      </el-row>
    </div>

    <!--COMPONENTE CARDS -->
    <div style="margin:6rem 6rem">
      <el-row :gutter="80">
        <el-col :span="12" v-for="(item, index) in materials.slice(0,30)" :key="index" style="margin-bottom: 3rem">
           <CardSuport 
            :stateOrder="item.stateBtnStorageSupport" :numberOrder="' '" :originalTitle="item.listTitle"
            :colorButton="item.colorBtnStorageSupport" :codMaterial="item.codMaterial" :titleToShow="theTitleIs(item)" :dataToShow="dataIs(item)"
            @eventEmit="changeRoute(item.__id, item, index, 'new')" />        
        </el-col>
      </el-row>
    </div>
  </div>
</template>

<script>

  import ReturnButton from '@/components/ReturnButton.vue'
  import Title from '@/components/Title.vue'    
  import SearchFilter from '@/components/searchFilter.vue'
  import { modifyText } from '../../../../utils/modifyText.js'
  import DescriptionStateOrders from '@/components/DescriptionStateOrders.vue' 
  import CardSuport from '@/components/CardSuport.vue'
  import { HTTP } from '../../../../main.js'
  import Select from '@/components/AppSelect.vue'


  export default {
    components: {
      ReturnButton,
      CardSuport,
      'app-search-filter': SearchFilter, 
      'app-title': Title,
      DescriptionStateOrders,
     'app-select': Select,

    },

    data () {
      return {
        textSearch: '',
        // typeMaterial: localStorage.getItem('typeMaterialR'),
        typeMaterialSelected: localStorage.getItem('typeMaterialSelected'),
        typeContent: localStorage.getItem('typeContent'),
        totalMaterials: [],
        televisaMat: [],
        originalTitle: '',
        filterSelect: '',
        // allFilters: [
        //   {value: 'originalTitle', label: 'Titulo Material'},
        //   {value: 'codMaterial', label: 'Código Material'},
        // ],
        // links: [],
        nameView : this.$localStorage.get('nameView'),
        withCaps: [
          {style: 'l-grey', name: 'No se ha copiado ningún capítulo'},
          {style: 'bg-red', name: 'Capítulos Incompletos'},
          {style: 'l-green', name: 'Capítulos Completos'}
        ],
        withoutCaps: [
          {style: 'l-grey', name: 'Pendiente'},
          {style: 'bg-red', name: 'Pendiente de Reposición'},
          {style: 'l-green', name: 'Copiado'}
        ]
      };
    },
    created() {
      
      // if(this.typeMaterialSelected == 'Especial'){
      //   this.getMaterialAffiliate(this.typeMaterialSelected)
      // } else if(this.typeMaterialSelected == 'Novelas'){
      //   this.getMaterialAffiliate('TELEVISA - TELENOVELAS')
      // } else if(this.typeMaterialSelected == 'Series'){
      //   this.getMaterialAffiliate('TELEVISA - SERIES')
      // }
      this.getMaterials()
    },
    computed: {
      // materials: { 
      //   get: function () {
      //    let totalMaterials = this.totalMaterials.filter(
      //      m => m.stateBtnSupport !== 'PENDIENTE'
      //    )

      //   let mShow = totalMaterials
      //     if (this.textSearch == '' && this.originalTitle == '') {
      //       mShow = totalMaterials
      //     }
      //     return mShow
      //   },
      //   set: function (newItem) {    
      //     let array = []
      //     array.push(newItem)
      //     this.totalMaterials = array
      //   }
      // }
      materials () {
        
        let mShow
        
        // if(this.typeMaterialSelected == 'Especial' || this.typeMaterialSelected == 'Novelas' || this.typeMaterialSelected == 'Series'){
        //   let allMaterials = this.totalMaterials.concat(this.televisaMat)
        //   let finalMaterial = allMaterials.filter(
        //     m => m.stateBtnSupport !== 'PENDIENTE'
        //   )
        //   mShow = this.orderDataByGeminisCode(finalMaterial)
				// } else {

					let finalMaterial = this.totalMaterials.filter(
            m => m.stateBtnSupport !== 'PENDIENTE'
          )
          mShow = this.orderDataByGeminisCode(finalMaterial)
          
				// }

        if (this.textSearch) {
          mShow = mShow.filter(
            m => modifyText(m.originalTitle).indexOf(modifyText(this.textSearch)) > -1) ||
                modifyText(m.ownTitle).indexOf(modifyText(this.textSearch)) > -1 ||
                modifyText(m.listTitle).indexOf(modifyText(this.textSearch)) > -1 
        }
        return mShow
      }
    },
    methods: {
      orderDataByGeminisCode (array) {
        array.sort(function (a, b) {
          if ( Number(a.geminisCode) < Number(b.geminisCode) ) {
            return 1;
          }
          if ( Number(a.geminisCode) > Number(b.geminisCode )) {
            return -1;
          }
          return 0;
        });
        return array
      },
      changeRoute(id, item, index, text) {
        console.log('hice click')
        this.$localStorage.set('itemSeleccionado', JSON.stringify(item))
        this.$localStorage.set('stateBtnStorageSupport', JSON.stringify(item.stateBtnStorageSupport))
        this.$localStorage.set('idSupportMat', JSON.stringify(id))
        if (item.numChapters.length >0) {
          console.log('----------')
          this.$router.push({ name: 'formAlmacenTelevisa' })
        }
        else {
          console.log('----------********************')
          this.$router.push({ name: 'almacenSinCap' })
        }
      },
      getMaterialAffiliate(material){
        
        console.log(material, 'material')

        HTTP.get('materials/materialType/'+material)
        .then(res => {
          this.televisaMat = res.data.materials
        })
        .catch(err => {
          console.log(err);
        });
      },
      getMaterials () {
        
        console.log(this.typeMaterialSelected, 'this.typeMaterialSelected')
         HTTP.get('materials/typeOfContent/' + this.typeMaterialSelected +  '/materialType/Televisa')
        .then(res => {
          this.totalMaterials = res.data.materials
          console.log( this.totalMaterials, ' this.totalMaterials')
        })
        .catch(err => console.log(err))
      },
      // querySearch(queryString, cb) {
      //   let filterMat = this.links.filter(
      //     m => m.stateBtnSupport !== 'PENDIENTE'
      //   )

      //   var links = filterMat;
      //   var results = queryString ? links.filter(this.createFilter(queryString)) : links;
      //   console.log(results, 'results')
      //   cb(results);
      // },
      // createFilter(queryString) {
      //   return (link) => {
      //     return (link[this.filterSelect].toLowerCase().indexOf(queryString.toLowerCase()) !== -1);
      //   };
      // },
      // handleSelect(item) {
      //   this.originalTitle = item[this.filterSelect]
      //   this.materials = item
      // },
      returnPage () {
        this.$router.push({name: 'Televisa'})
      },
      theTitleIs(value) {
        if(value.numChapters.length > 0) {
          return 'Temporada'
        } else {
          return 'Fecha de Copiado'
        }
      },
      dataIs(value) {
        if(value.numChapters.length > 0) {
          return value.numChapters[0].season
        } else {
          return value.infoSupport.length > 0 && value.infoSupport[0].dateOfCopy !== '' ? new Date(value.infoSupport[0].dateOfCopy).toLocaleDateString('en-GB') : ''
        }
      }
    },
  }
</script>